#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityElevenCollectingCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityElevenCollectingCFG> M_ActivityElevenCollectingCFG::msSingleton(nullptr);

int M_ActivityElevenCollectingCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityElevenCollectingCFGData* M_ActivityElevenCollectingCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityElevenCollectingCFGData>& M_ActivityElevenCollectingCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityElevenCollectingCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityElevenCollectingCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityElevenCollectingCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mCollectingType = element->IntAttribute("CollectingType");
		{
			const char* CollectingReward = element->Attribute("CollectingReward");
			std::vector<std::string> vecCollectingReward;
			boost::split(vecCollectingReward, CollectingReward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCollectingReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCollectingReward[i].c_str(), &temp))
				{
					data.mCollectingReward.push_back(temp);
				}
			}
		}
		{
			const char* CollectingQuantity = element->Attribute("CollectingQuantity");
			std::vector<std::string> vecCollectingQuantity;
			boost::split(vecCollectingQuantity, CollectingQuantity, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCollectingQuantity.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCollectingQuantity[i].c_str(), &temp))
				{
					data.mCollectingQuantity.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityElevenCollectingCFG::Load()
{
	Load("../Config/M_ActivityElevenCollectingCFG.xml");
}

M_ActivityElevenCollectingCFG* M_ActivityElevenCollectingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityElevenCollectingCFG());
	}
	return msSingleton.get();
}
